
--
--  Gossipmonger
--    by Tuhljin
--
--  QuestHanger.lua
--

local frame = CreateFrame("Button", "Gossipmonger_QuestHanger", QuestFrame)
frame:SetWidth(24); frame:SetHeight(24);
frame:SetPoint("TOPRIGHT", QuestFrameCloseButton, "BOTTOMRIGHT", -15, 0)
frame:SetFrameLevel(QuestFrame:GetFrameLevel() + 1)
frame.tex = frame:CreateTexture(nil, "ARTWORK")
frame.tex:SetTexture("Interface\\AddOns\\Gossipmonger\\OpenBubbleBtn")
frame.tex:SetWidth(24); frame.tex:SetHeight(24);
frame.tex:SetPoint("LEFT")
frame.texhighlight = frame:CreateTexture(nil, "HIGHLIGHT")
frame.texhighlight:SetTexture("Interface\\AddOns\\Gossipmonger\\OpenBubbleBtnHighlight")
frame.texhighlight:SetWidth(24); frame.texhighlight:SetHeight(24);
frame.texhighlight:SetPoint("CENTER", frame.tex, "CENTER")
frame:Hide()

local function CheckShow()
  if (not QuestFrame:IsShown()) then  return;  end
  if (not Gossipmonger_MirrorFrame:IsShown() and Gossipmonger_MirrorFrame.NPCName == UnitName("npc") and
      (Gossipmonger_MirrorFrame.numOptions or 0) > 1) then
    frame:Show()
  else
    frame:Hide()
  end
end

local function OnEvent(self, event)
  if (event == "QUEST_GREETING") then
    frame:Hide()
    return;
  end
  CheckShow()
  if (not Gossipmonger_MirrorFrame.selected) then
  -- Find the option button that corresponds to the selected quest and mark it as selected:
    local title = GetTitleText()
    local btn
    for i=1,Gossipmonger_MirrorFrame.numOptions or 0 do
      btn = _G["Gossipmonger_OptionDisplay"..i]
      if (not btn) then
        break;
      elseif (btn.title == title and btn.type ~= "Gossip") then
        Gossipmonger.PrepGossipOptionDisplay(i, btn.baseButton, true, btn.QuestGreeting)
        Gossipmonger_MirrorFrame.selected = i
        break;
      end
    end
  end
end

frame:SetScript("OnClick", Gossipmonger.ShowMirror)
frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent("QUEST_DETAIL")
frame:RegisterEvent("QUEST_PROGRESS")
frame:RegisterEvent("QUEST_COMPLETE")
frame:RegisterEvent("QUEST_GREETING")

Gossipmonger_MirrorFrame:HookScript("OnShow", CheckShow)
Gossipmonger_MirrorFrame:HookScript("OnHide", CheckShow)


-- ADDON COMPATIBILITY
-------------------------

-- ADDON: Wholly
-- This addon adds a frame that can get in the way of the button we add to the quest frame, so we'll move it.
if (com_mithrandir_whollyQuestInfoFrame) then
  local point, relativeTo, relativePoint, xOffset, yOffset = com_mithrandir_whollyQuestInfoFrame:GetPoint() -- We know there's only one point, so this should be good enough. If Wholly changes this, this code may need to change as well.
  com_mithrandir_whollyQuestInfoFrame:SetPoint(point, relativeTo, relativePoint, xOffset - 30, yOffset)
end
